"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _findKey = _interopRequireDefault(require("@dword-design/functions/dist/find-key"));

var _keys = _interopRequireDefault(require("@dword-design/functions/dist/keys"));

var _replace = _interopRequireDefault(require("@dword-design/functions/dist/replace"));

var _some = _interopRequireDefault(require("@dword-design/functions/dist/some"));

var _startsWith = _interopRequireDefault(require("@dword-design/functions/dist/starts-with"));

var _babelPluginModuleResolver = require("babel-plugin-module-resolver");

var _findUp = _interopRequireDefault(require("find-up"));

var _path = _interopRequireDefault(require("path"));

var _pkgUp = _interopRequireDefault(require("pkg-up"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isParentImport = path => /^(\.\/)?\.\.\//.test(path);

var _default = {
  meta: {
    type: 'suggestion',
    fixable: true,
    schema: [{
      type: 'object',
      properties: {
        alias: {
          type: 'object'
        }
      }
    }]
  },
  create: context => {
    const options = {
      alias: {
        '@': '.'
      },
      ...context.options[0]
    };
    const path = context.getFilename();

    const folder = _path.default.dirname(path); // can't check a non-file


    if (path === '<text>') return {};
    return {
      ImportDeclaration: node => {
        var _ref, _options$alias, _importPath2, _importWithoutAlias;

        const importPath = node.source.value;
        const hasAlias = (_ref = (_options$alias = options.alias, (0, _keys.default)(_options$alias)), (0, _some.default)(alias => {
          var _importPath;

          return _importPath = importPath, (0, _startsWith.default)(`${alias}/`)(_importPath);
        })(_ref));
        const importWithoutAlias = (0, _babelPluginModuleResolver.resolvePath)(importPath, path, options);

        const resolvedCwd = (() => {
          var _pkgUp$sync, _findUp$sync;

          switch (options.cwd) {
            case 'packagejson':
              return _pkgUp$sync = _pkgUp.default.sync({
                cwd: folder
              }), _path.default.dirname(_pkgUp$sync);

            case 'babelrc':
              return _findUp$sync = _findUp.default.sync('.babelrc.json', {
                cwd: folder
              }), _path.default.dirname(_findUp$sync);

            default:
              return options.cwd || '.';
          }
        })(); // relative parent


        if (_importPath2 = importPath, isParentImport(_importPath2)) {
          var _options$alias2, _P$relative;

          const absoluteImportPath = _path.default.resolve(folder, importPath);

          const matchingAlias = (_options$alias2 = options.alias, (0, _findKey.default)(aliasPath => {
            var _absoluteImportPath;

            return _absoluteImportPath = absoluteImportPath, (0, _startsWith.default)(_path.default.resolve(resolvedCwd, aliasPath))(_absoluteImportPath);
          })(_options$alias2));

          if (!matchingAlias) {
            return context.report({
              node,
              message: `Unexpected parent import '${importPath}'. No matching alias found to fix the issue`
            });
          }

          const rewrittenImport = `${matchingAlias}/${(_P$relative = _path.default.relative(_path.default.resolve(resolvedCwd, options.alias[matchingAlias]), absoluteImportPath), (0, _replace.default)(/\\/g, '/')(_P$relative))}`;
          return context.report({
            node,
            message: `Unexpected parent import '${importPath}'. Use '${rewrittenImport}' instead`,
            fix: fixer => fixer.replaceTextRange([node.source.range[0] + 1, node.source.range[1] - 1], rewrittenImport)
          });
        }

        if (!(_importWithoutAlias = importWithoutAlias, isParentImport(_importWithoutAlias)) && hasAlias) {
          return context.report({
            node,
            message: `Unexpected subpath import via alias '${importPath}'. Use '${importWithoutAlias}' instead`,
            fix: fixer => fixer.replaceTextRange([node.source.range[0] + 1, node.source.range[1] - 1], importWithoutAlias)
          });
        }

        return undefined;
      }
    };
  }
};
exports.default = _default;
module.exports = exports.default;